#include "bins.h"
#include <math.h>

gboolean create_demuxer(NvDsPipeline *pipeline, NvDsConfig *config, GstElement *lastElem)
{
    gboolean ret = FALSE;

    pipeline->demuxer = gst_element_factory_make(NVDS_ELEM_STREAM_DEMUX, "demuxer");
    if (!pipeline->demuxer)
    {
        NVGSTDS_ERR_MSG_V("Failed to create element 'demuxer'");
        goto done;
    }
    gst_bin_add(GST_BIN(pipeline->pipeline), pipeline->demuxer);

    NVGSTDS_LINK_ELEMENT(lastElem, pipeline->demuxer);

    ret = TRUE;
done:
    if (!ret)
        NVGSTDS_ERR_MSG_V("%s failed", __func__);

    return ret;
}
