#include "bins.h"

gboolean
create_source(NvDsPipeline *pipeline, NvDsConfig *config, GstElement **lastElem)
{
  gboolean ret = FALSE;

  if (!create_multi_source_bin(config->num_source_sub_bins, config->multi_source_config,
                               &pipeline->multi_src_bin))
    goto done;
  gst_bin_add(GST_BIN(pipeline->pipeline), pipeline->multi_src_bin.bin);
  
  
  if (!set_streammux_properties(&config->streammux_config,
                                pipeline->multi_src_bin.streammux))
    NVGSTDS_WARN_MSG_V("Failed to set streammux properties");

  *lastElem = pipeline->multi_src_bin.bin;

  ret = TRUE;
done:
  if (!ret)
    NVGSTDS_ERR_MSG_V("%s failed", __func__);

  return ret;
}