/* ---------------------------------------------------------------------------
                              Metadata functions
 -----------------------------------------------------------------------------*/
#ifndef METADATA_H
#define METADATA_H

#include <gst/gst.h>

/**
 * @brief Callback function to receive messages from components
 * in the pipeline.
 *
 * @param bus
 * @param message
 * @param data
 * @return gboolean
 */
gboolean bus_callback(GstBus *bus, GstMessage *message, gpointer data);

/**
 * @brief Function to process the attached metadata 
 * before OSD or sink (in case OSD is disabled).
 * Updates relay state, audio player state and video logger state.
 * Process information from BRIEF checker.
 *
 * @param pad
 * @param info
 * @param u_data - stores AppCtx - the main structure of app.
 * @return GstPadProbeReturn
 */
GstPadProbeReturn process_metadata(GstPad *pad, GstPadProbeInfo *info,
                                   gpointer u_data);

#endif
