#include "utils.h"

static GMutex fps_lock;
static gdouble fps[MAX_SOURCE_BINS];
static gdouble fps_avg[MAX_SOURCE_BINS];

void perf_cb(gpointer context, NvDsAppPerfStruct *str)
{
  static guint header_print_cnt = 0;
  AppCtx *appCtx = (AppCtx *)context;
  guint numf = str->num_instances;
  gchar *fps_info;
  time_t current_time;
  g_mutex_lock(&fps_lock);

  for (guint i = 0; i < numf; i++)
  {
    fps[i] = str->fps[i];
    fps_avg[i] = str->fps_avg[i];
  }

  if (header_print_cnt % 20 == 0)
  {
    gchar fps_header_init[13];
    g_snprintf(fps_header_init, 13, "\n**PERF:  ");
    fps_info = fps_header_init;
    for (guint i = 0; i < numf; i++)
    {
      gchar fps_avg[20];
      g_snprintf(fps_avg, sizeof(fps_avg), "FPS %d (Avg)\t", i);
      fps_info = g_strconcat(fps_info, fps_avg, NULL);
    }
    NVGSTDS_INFO_MSG_V("%s\n", fps_info);
    header_print_cnt = 0;
  }
  header_print_cnt++;

  gchar fps_info_init[13];
  g_snprintf(fps_info_init, 13, "**PERF:  ");
  fps_info = fps_info_init;

  for (guint i = 0; i < numf; i++)
  {
    gchar fps_info_[20];
    g_snprintf(fps_info_, sizeof(fps_info_), "%.2f (%.2f)\t", fps[i], fps_avg[i]);
    fps_info = g_strconcat(fps_info, fps_info_, NULL);
  }

  NVGSTDS_INFO_MSG_V("%s\n", fps_info);
  g_mutex_unlock(&fps_lock);
}
